<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select
          v-model:value="model[field]"
          placeholder="请选择行业分类"
          :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions"
          @change="changeSuspect"
        ></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select
          v-model:value="model[field]"
          show-search
          placeholder="请选择二级"
          allow-clear
          tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }"
          :tree-data="treeData"
          tree-node-filter-prop="label"
        >
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" v-auth="'dkdc-pshdws-jbxx'">查看基本信息</a-button>
        <a-button type="primary" @click="handleComint" v-auth="'dkdc-dqr-dqr'">待确认</a-button>
      </template>
    </BasicTable>
    <ConfirmedModal @register="registerModal" @success="handleSuccess" />
  </div>
</template>

<script lang="ts" name="dkgl-investigate-Improved" setup>
  import { BasicTable } from '/@/components/Table';
  import { useRouter } from 'vue-router';
  import { useModal } from '/@/components/Modal';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useListPage } from '/@/hooks/system/useListPage';
  import ConfirmedModal from '@/components/customComponent/ConfirmedModal.vue';
  import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
  import { improvedList, getImportUrl, getExportUrl } from './api';

  let router = useRouter();
  //注册model
  const [registerModal, { openModal }] = useModal();
  const { createMessage } = useMessage();
  //注册table数据
  const { tableContext } = useListPage({
    tableProps: {
      title: '地块管理-评审中待完善',
      api: improvedList,
      columns,
      canResize: false,
      //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
      rowKey: 'wrdkid',
      clickToRowSelect: true,
      rowSelection: { type: 'radio' },
      formConfig: {
        labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: false,
      },
      showActionColumn: false,
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
    },
    exportConfig: {
      name: '地块管理-评审中待完善',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
    },
  });
  const isSuspectOptions = useSuspectsData().data; // 行业分类
  const useCategory = useCategoryData();
  const treeData = useCategory.data; // 行业类别-数据
  const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
  const [registerTable, { reload }, { rowSelection, selectedRowKeys, selectedRows }] = tableContext;

  function handleAdd() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    router.push(`/dkgl/investigate/modal/ViewData?wrdkid=${selectedRowKeys.value[0]}`);
  }
  function handleComint() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    if (selectedRows.value[0].jdnzt == '待受理' && selectedRows.value[0].sfthxg == 1) {
      openModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
      });
    }else{
      createMessage.info('数据还未提交，请提交后再进行操作');
    }
  }
  function handleSuccess() {
    selectedRows.value = [];
    selectedRowKeys.value = [];
    reload();
  }
</script>
<style scoped></style>
